%bcond_without	ruby
%bcond_with	python
%bcond_without	perl

Summary:	ClearSilver HTML template system
Name:		clearsilver
Version:	0.10.5
Release:	%mkrel 36
License:	BSD License
Group:		Networking/WWW
Source0:	http://www.clearsilver.net/downloads/%{name}-%{version}.tar.bz2
Patch0:		clearsilver-0.10.5-mandriva.patch
Patch1:		clearsilver-0.10.5-regression.patch
Patch2:		clearsilver-0.10.5-CVE-2011-4357.patch
Patch3:		clearsilver-ruby-1.9.patch
Patch4:		clearsilver-ruby-2.2.patch
# GCC 5 compatibility, bug #1190760
Patch5:		clearsilver-0.10.5-gcc5.patch
Patch6:		clearsilver-configure-c99.patch
Patch7:		clearsilver-fix-build-with-gcc14.patch
URL:		http://www.clearsilver.net/
BuildRequires:	pkgconfig(zlib)
%if %{with python}
BuildRequires:	pkgconfig(python3)
%endif
%if %{with perl}
BuildRequires:	perl-devel
%endif
%if %{with ruby}
BuildRequires:	pkgconfig(ruby) >= 1.4.5
BuildRequires:	ruby(rubygems)
%endif

%description
ClearSilver is a fast, powerful, and language-neutral HTML template system.
In both static content sites and dynamic HTML applications, it provides a
separation between presentation code and application logic which makes
working with your project easier.

Because it's written as a C-library, and exported to scripting languages
like Python and Perl via modules, it is extremely fast compared to template
systems written in a script language.

%package	devel
Summary:	ClearSilver development package
Group:		Development/C

%description devel
This package provides needed files to develop extension
to ClearSilver.

%if %{with python}
%package -n	python-%{name}
Summary:	Neotonic ClearSilver Python Module
Group:		Development/Python
Requires:	clearsilver = %{version}

%description -n	python-%{name}
This package provides a python interface to the
clearsilver CGI kit and templating system.
%endif

%if %{with perl}
%package -n	perl-ClearSilver
Summary:	Neotonic ClearSilver Perl Module
Group:		Development/Perl
Requires:	clearsilver = %{version}

%description -n perl-ClearSilver
The clearsilver-perl package provides a perl interface to the
clearsilver templating system.
%endif

%if %{with ruby}
%package -n	ruby-%{name}
Summary:	Neotonic ClearSilver Ruby Module
Group:		Development/Ruby
Requires:	clearsilver = %{version}

%description -n	ruby-%{name}
The clearsilver-ruby package provides a ruby interface to the
clearsilver templating system.
%endif

%prep
%setup -q
%patch -P 0 -p0
%patch -P 1 -p1
%patch -P 2 -p1
%patch -P 3 -p1 -b .ruby19~
%patch -P 4 -p1
%patch -P 5 -p2
%patch -P 6 -p1
%patch -P 7 -p1
touch configure
sed -i -r 's|(\$\(RUBY\) install.rb config) (--.*)|\1 --rb-dir="$(DESTDIR)%{ruby_vendorlibdir}" --so-dir="$(DESTDIR)%{ruby_vendorarchdir}" \2|' ruby/Makefile

# fix build on aarch64
cp -af %{_rpmconfigdir}/%{_real_vendor}/config.{guess,sub} .

%build
%configure	--disable-apache \
		--disable-java \
		--disable-csharp \
%if %{with ruby}
		--enable-ruby \
%else
		--disable-ruby \
%endif
%if %{with perl}
		--enable-perl \
%else
		--disable-perl \
%endif
%if %{with python}
		--enable-python
%else
		--disable-python
%endif
perl -pi -e 's#install.rb install$#install.rb install --prefix=%{buildroot}#' ruby/Makefile
perl -pi -e 's/555/755/' ruby/install.rb

%make_build

%if %{with python}
cd python
LDSHARED="gcc -shared -lz %{ldflags}" %{__python3} setup.py build
%endif

%install
perl -pi -e 's#/usr/local/#/usr/#' scripts/document.py
%if %{with perl}
cd perl
perl Makefile.PL INSTALLDIRS=vendor
%make_install
cd ..
%endif
%make_install

%if %{with python}
cd python
%{__python3} setup.py install --root=%{buildroot}
cd ..
%endif

find %{buildroot} -name '*.so' -exec chmod u+w {} \;

#
# TODO add script ( in script/ subdir )
# emacs mode
%files
%doc CS_LICENSE INSTALL LICENSE README scripts/cs_lint.py contrib/cs-mode.el
%{_bindir}/*
%{_mandir}/man3/*.3.*

%files devel
%{_includedir}/ClearSilver/
%{_libdir}/libneo_cgi.a
%{_libdir}/libneo_cs.a
%{_libdir}/libneo_utl.a

%if %{with python}
%files -n python-%{name}
%doc README.python
%{python3_sitearch}/neo_cgi.so
%{python3_sitearch}/clearsilver-%{version}-py%{python3_version}.egg-info
%endif

%if %{with perl}
%files -n perl-ClearSilver
%{perl_vendorarch}/ClearSilver.pm
%{perl_vendorarch}/auto/ClearSilver/ClearSilver.so
%dir %{perl_vendorarch}/auto/ClearSilver/
%{_mandir}/man3/*.3pm*
%endif

%if %{with ruby}
%defattr(-,root,root)
%{ruby_vendorarchdir}/hdf.so
%{ruby_vendorlibdir}/neo.rb
%endif



%changelog
* Sat Feb 01 2025 pterjan <pterjan> 0.10.5-36.mga10
+ Revision: 2144265
- Rebuild for Ruby 3.4

* Wed Dec 04 2024 pterjan <pterjan> 0.10.5-35.mga10
+ Revision: 2120940
- Rebuild for Ruby 3.3

* Sat Nov 23 2024 ns80 <ns80> 0.10.5-34.mga10
+ Revision: 2118688
- try to fix patch clearsilver-ruby-1.9
- try to fix building with GCC14
- resync a bit with Fedora
+ tv <tv>
- Rebuild for perl-5.40
+ daviddavid <daviddavid>
- rebuild for new perl

* Fri Jun 24 2022 papoteur <papoteur> 0.10.5-31.mga9
+ Revision: 1865857
- Mass Rebuild for dependencies
+ umeabot <umeabot>
- Rebuild for Perl 5.36

* Fri Mar 25 2022 umeabot <umeabot> 0.10.5-29.mga9
+ Revision: 1827002
- Mageia 9 Mass Rebuild
+ pterjan <pterjan>
- Rebuild for Ruby 3.1

* Mon May 24 2021 umeabot <umeabot> 0.10.5-27.mga9
+ Revision: 1726355
- Rebuild for perl 5.34

* Wed Jun 17 2020 umeabot <umeabot> 0.10.5-26.mga8
+ Revision: 1594204
- Rebuild for perl 5.32

* Mon Mar 02 2020 pterjan <pterjan> 0.10.5-25.mga8
+ Revision: 1553133
- Rebuild for ruby 2.7

* Sun Feb 16 2020 daviddavid <daviddavid> 0.10.5-24.mga8
+ Revision: 1529996
- disable python support until a python3 port
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Tue Aug 27 2019 tmb <tmb> 0.10.5-23.mga8
+ Revision: 1433402
- rebuild for perl 5.30

* Sat Sep 22 2018 umeabot <umeabot> 0.10.5-22.mga7
+ Revision: 1296581
- Mageia 7 Mass Rebuild

* Mon Aug 06 2018 shlomif <shlomif> 0.10.5-21.mga7
+ Revision: 1248204
- Rebuild for new perl 5.28.0

* Tue Jun 05 2018 wally <wally> 0.10.5-20.mga7
+ Revision: 1234733
- fix build on aarch64
- use new make macros
- use configure2_5x macro

* Mon Jan 01 2018 pterjan <pterjan> 0.10.5-19.mga7
+ Revision: 1188454
- Rebuild for Ruby 2.5

* Wed Sep 13 2017 tv <tv> 0.10.5-18.mga7
+ Revision: 1153535
- fix build with new ruby
+ cjw <cjw>
- add buildrequires ruby(rubygems)
+ pterjan <pterjan>
- Rebuild for perl ABI changes
- Rebuild for perl ABI changes
- Rebuild for new Ruby

* Sat Jul 22 2017 neoclust <neoclust> 0.10.5-16.mga7
+ Revision: 1127639
- Rebuild against new Perl 5.26

* Sat Jun 18 2016 pterjan <pterjan> 0.10.5-15.mga6
+ Revision: 1022104
- Rebuild for perl 5.22.2

* Sat Feb 20 2016 umeabot <umeabot> 0.10.5-14.mga6
+ Revision: 972329
- Mageia 6 Mass Rebuild

* Mon Nov 02 2015 tv <tv> 0.10.5-13.mga6
+ Revision: 897431
- submit to core/releaes

* Mon Nov 02 2015 tv <tv> 0.10.5-12.mga6
+ Revision: 897424
- just use the right python version
- fix both local & BS builds
- adjust file list
- add gcc5 & ruby 2.2 fixes from FC

* Fri Jun 26 2015 sander85 <sander85> 0.10.5-8.mga6
+ Revision: 844036
- Rebuild for perl 5.22

* Wed Oct 15 2014 umeabot <umeabot> 0.10.5-7.mga5
+ Revision: 741738
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0.10.5-6.mga5
+ Revision: 726048
- rebuild for missing pythoneggs deps

* Thu Sep 18 2014 umeabot <umeabot> 0.10.5-5.mga5
+ Revision: 693620
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 0.10.5-4.mga5
+ Revision: 678423
- Mageia 5 Mass Rebuild

* Tue Jun 03 2014 pterjan <pterjan> 0.10.5-3.mga5
+ Revision: 630765
- Rebuild for perl 5.20

* Sat May 31 2014 pterjan <pterjan> 0.10.5-2.mga5
+ Revision: 628131
- Rebuild for new Python

* Sat Dec 21 2013 nanardon <nanardon> 0.10.5-1.mga4
+ Revision: 559498
- cleanup and policy
- imported package clearsilver

